/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class addi extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               addi.class,
               "addi",
               false,
               new ParamDecls()
                   .declareParam("rt", REG.INFO)
                   .declareParam("rs", REG.INFO)
                   .declareParam("imm", SHORT),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final Location imm = (Location) getArgument("imm", args);

            return new addi(rt, rs, imm);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "addi",
                true,
                new ParamDecls()
                    .declareParam("rt", REG.INFO)
                    .declareParam("rs", REG.INFO)
                    .declareParam("imm", SHORT)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final Location imm = (Location) getArgument("imm", args);

            return new instruction(
                new addi(
                    rt,
                    rs,
                    imm
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rt;
    private final IAddressingMode rs;
    private final Location imm;

    public addi(IAddressingMode rt, IAddressingMode rs, Location imm)
    {
        assert REG.INFO.isSupported(rt);
        assert REG.INFO.isSupported(rs);
        assert SHORT.equals(imm.getType());

        this.rt = rt;
        this.rs = rs;
        this.imm = imm;
    }

    @Override
    public String syntax()
    {
        return String.format("addi %s, %s, %d", rt.syntax(), rs.syntax(), imm.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s%d", rs.image(), rt.image(), imm.load().getRawData().intValue());
    }

    @Override
    public void action()
    {
        temp.access().store(DataEngine.execute(EOperatorID.PLUS, Location.concat(rs.access(), rs.access().bitField(31, 31)).load(), DataEngine.coerce(Type.INT(33), imm.load())));
        if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, temp.access().bitField(32, 32).load(), temp.access().bitField(31, 31).load())))
        {
            exception("IntegerOverflow");
        }
        else
        {
            rt.access().store(temp.access().bitField(31, 0).load());
        }
    }
}
