/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class bltzal extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               bltzal.class,
               "bltzal",
               false,
               new ParamDecls()
                   .declareParam("rs", REG.INFO)
                   .declareParam("offset", SHORT),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final Location offset = (Location) getArgument("offset", args);

            return new bltzal(rs, offset);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "bltzal",
                true,
                new ParamDecls()
                    .declareParam("rs", REG.INFO)
                    .declareParam("offset", SHORT)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final Location offset = (Location) getArgument("offset", args);

            return new instruction(
                new bltzal(
                    rs,
                    offset
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rs;
    private final Location offset;

    public bltzal(IAddressingMode rs, Location offset)
    {
        assert REG.INFO.isSupported(rs);
        assert SHORT.equals(offset.getType());

        this.rs = rs;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("bltzal %s, <label>%d", rs.syntax(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("000001%s00000%d", rs.image(), offset.load().getRawData().intValue());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(rs.access().load()) < 0)
        {
            GPR.access(31).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 4)), DataEngine.valueOf(WORD, 4)));
            BRANCH.access().store(DataEngine.valueOf(Type.INT(1), 1));
            JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.coerce(WORD, DataEngine.execute(EOperatorID.MUL, DataEngine.valueOf(SHORT, 4), offset.load()))), DataEngine.valueOf(WORD, 4)));
        }
    }
}
