/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IOperation;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class instruction extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               instruction.class,
               "instruction",
               true,
               new ParamDecls()
                   .declareParam("command", Operations.INFO));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IOperation command = (IOperation) getArgument("command", args);

            return new instruction(command);
        }
    }

    public static final IInfo INFO = new Info();

    private final IOperation command;

    public instruction(IOperation command)
    {
        assert Operations.INFO.isSupported(command);

        this.command = command;
    }

    @Override
    public String syntax()
    {
        return command.syntax();
    }

    @Override
    public String image()
    {
        return command.image();
    }

    @Override
    public void action()
    {
        GPR.access(0).store(DataEngine.coerce(WORD, DataEngine.valueOf(Type.INT(1), 0)));
        if (DataEngine.intValue(BRANCH.access().load()) == 0)
        {
            CIA.access().store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 4)));
        }
        else
        {
            CIA.access().store(JMPADDR.access().load());
            __CTRL_TRANSFER.set(1);
        }
        BRANCH.access().store(DataEngine.valueOf(Type.INT(1), 0));
        command.action();
    }
}
