/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class BNE extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               BNE.class,
               "BNE",
               false,
               new ParamDecls()
                   .declareParam("rs", R.INFO)
                   .declareParam("rt", R.INFO)
                   .declareParam("offset", SHORT));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location offset = (Location) getArgument("offset", args);

            return new BNE(rs, rt, offset);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rs;
    private final IAddressingMode rt;
    private final Location offset;

    public BNE(IAddressingMode rs, IAddressingMode rt, Location offset)
    {
        assert R.INFO.isSupported(rs);
        assert R.INFO.isSupported(rt);
        assert SHORT.equals(offset.getType());

        this.rs = rs;
        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("BNE %s, %s, <label>%d", rs.syntax(), rt.syntax(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("000101%s%s%s", rs.image(), rt.image(), offset.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, rs.access().load(), rt.access().load())))
        {
            BRANCH.access().store(DataEngine.valueOf(Type.INT(1), 1));
            JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(Type.INT(32), NIA.access().load()), DataEngine.coerce(Type.INT(32), DataEngine.execute(EOperatorID.L_SHIFT, offset.load(), DataEngine.valueOf(SHORT, 3)))));
        }
    }
}
