/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class C_LE_S extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               C_LE_S.class,
               "C_LE_S",
               false,
               new ParamDecls()
                   .declareParam("ft", F.INFO)
                   .declareParam("fs", F.INFO)
                   .declareParam("cc", COND_CODE));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode ft = (IAddressingMode) getArgument("ft", args);
            final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);
            final Location cc = (Location) getArgument("cc", args);

            return new C_LE_S(ft, fs, cc);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode ft;
    private final IAddressingMode fs;
    private final Location cc;

    public C_LE_S(IAddressingMode ft, IAddressingMode fs, Location cc)
    {
        assert F.INFO.isSupported(ft);
        assert F.INFO.isSupported(fs);
        assert COND_CODE.equals(cc.getType());

        this.ft = ft;
        this.fs = fs;
        this.cc = cc;
    }

    @Override
    public String syntax()
    {
        return String.format("C_LE_S %d, %s, %s", cc.load().getRawData().intValue(), fs.syntax(), ft.syntax());
    }

    @Override
    public String image()
    {
        return String.format("01000110000%s%s%s00111110", ft.image(), fs.image(), cc.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.LESS_EQ, fs.access().load(), ft.access().load())))
        {
            FCCR.access().bitField(DataEngine.intValue(cc.load()), DataEngine.intValue(cc.load())).store(DataEngine.valueOf(Type.INT(1), 1));
        }
        else
        {
            FCCR.access().bitField(DataEngine.intValue(cc.load()), DataEngine.intValue(cc.load())).store(DataEngine.valueOf(Type.INT(1), 0));
        }
    }
}
