/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.shared;

import ru.ispras.microtesk.model.api.type.TypeId;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final String PC = "CIA";

    public static final int REG_INDEX_SIZE = 5;
    public static final int INSTRUCTION_WORD_SIZE = 4;

    public static final Type LONG = Type.typeDef("LONG", Type.INT(32));
    public static final Type WORD = Type.typeDef("WORD", Type.CARD(32));
    public static final Type SHORT = Type.typeDef("SHORT", Type.INT(16));
    public static final Type HWORD = Type.typeDef("HWORD", Type.CARD(16));
    public static final Type SBYTE = Type.typeDef("SBYTE", Type.INT(8));
    public static final Type BYTE = Type.typeDef("BYTE", Type.CARD(8));
    public static final Type BIT = Type.typeDef("BIT", Type.CARD(1));
    public static final Type INDEX = Type.typeDef("INDEX", Type.CARD(REG_INDEX_SIZE));
    public static final Type SINGLE = Type.typeDef("SINGLE", Type.FLOAT(23, 8));
    public static final Type COND_CODE = Type.typeDef("COND_CODE", Type.CARD(3));

    public static final Memory GPR = Memory.REG("GPR", LONG, (int)Math.pow(2, REG_INDEX_SIZE));
    public static final Memory FPR = Memory.REG("FPR", SINGLE, (int)Math.pow(2, REG_INDEX_SIZE));
    public static final Memory M = Memory.MEM("M", BYTE, (int)Math.pow(2, 31));
    public static final Memory CIA = Memory.REG("CIA", WORD, 1);
    public static final Memory FCCR = Memory.REG("FCCR", LONG, 1);
    public static final Memory NIA = Memory.VAR("NIA", WORD, 1);
    public static final Memory JMPADDR = Memory.VAR("JMPADDR", WORD, 1);
    public static final Memory BRANCH = Memory.VAR("BRANCH", BIT, 1);
    public static final Memory temp = Memory.VAR("temp", Type.CARD(33), 1);

    public static final Memory[] __REGISTERS = {GPR, FPR, CIA, FCCR};
    public static final Memory[] __MEMORY = {M};
    public static final Memory[] __VARIABLES = {NIA, JMPADDR, BRANCH, temp};
    public static final Label[] __LABELS = {new Label("PC", CIA, 0)};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 